#! /usr/bin/python3

################################################################################
# flexiWAN SD-WAN software - flexiEdge, flexiManage.
# For more information go to https://flexiwan.com
#
# Copyright (C) 2021  flexiWAN Ltd.
#
# This program is free software: you can redistribute it and/or modify it under
# the terms of the GNU Affero General Public License as published by the Free
# Software Foundation, either version 3 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <https://www.gnu.org/licenses/>.
################################################################################

import cherrypy
from mediator import Mediator


@cherrypy.expose
class DeviceModule:
    def __init__(self):
        self.mediator = Mediator()

    @cherrypy.tools.accept(media="text/plain")
    @cherrypy.tools.json_out()
    def GET(self):
        return self.mediator.get_device_info()

    @cherrypy.tools.accept(media="application/json")
    @cherrypy.tools.json_in()
    @cherrypy.tools.json_out()
    def PUT(self):
        data = cherrypy.request.json
        print(data)
        cherrypy.response.headers[
            "Access-Control-Allow-Methods"
        ] = "GET, POST, PATCH, PUT, DELETE, OPTIONS"
        cherrypy.response.headers[
            "Access-Control-Allow-Headers"
        ] = "Origin, Content-Type, Accept, Access-Control-Allow-Headers"
        cherrypy.response.headers[
            "Access-Control-Allow-Origin"
        ] = cherrypy.request.headers.get("Origin", "*")
        status, response = self.mediator.apply_device_command(data)
        if status == True:
            return response
        cherrypy.response.status = 500
        return {"error": response}
