#! /usr/bin/python3

################################################################################
# flexiWAN SD-WAN software - flexiEdge, flexiManage.
# For more information go to https://flexiwan.com
#
# Copyright (C) 2022  flexiWAN Ltd.
#
# This program is free software: you can redistribute it and/or modify it under
# the terms of the GNU Affero General Public License as published by the Free
# Software Foundation, either version 3 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <https://www.gnu.org/licenses/>.
################################################################################

import cherrypy
from mediator import Mediator


@cherrypy.expose
class JobsModule:
    def __init__(self):
        self.mediator = Mediator()

    def OPTIONS(self):
        cherrypy.response.status = 204
        return ""

    @cherrypy.tools.accept(media="text/plain")
    @cherrypy.tools.json_out()
    def GET(self):
        status, response = self.mediator.get_device_jobs()
        if not status is True:
            cherrypy.response.status = 500
            return {"error": response}
        # Sort jobs by ID, descending
        if 'jobs' in response and type(response['jobs']) is list:
            response['jobs'] = sorted(response['jobs'], key=lambda j:j['job_id'], reverse=True)
        return response
