#! /usr/bin/python3

################################################################################
# flexiWAN SD-WAN software - flexiEdge, flexiManage.
# For more information go to https://flexiwan.com
#
# Copyright (C) 2021  flexiWAN Ltd.
#
# This program is free software: you can redistribute it and/or modify it under
# the terms of the GNU Affero General Public License as published by the Free
# Software Foundation, either version 3 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <https://www.gnu.org/licenses/>.
################################################################################

import cherrypy
from mediator import Mediator


@cherrypy.expose
class LogsModule:
    def __init__(self):
        self.mediator = Mediator()

    @cherrypy.tools.accept(media="text/plain")
    @cherrypy.tools.json_out()
    @cherrypy.popargs("filter")
    @cherrypy.popargs("limit")
    def GET(self, filter, limit):
        status, response = self.mediator.get_device_logs(filter, limit)
        if not status == True:
            cherrypy.response.status = 500
            return {"error": response}
        return response
