import os
import subprocess
import sys
import base64

backend_path = os.path.realpath(
    os.path.join(os.path.dirname(os.path.realpath(__file__)), "../")
)
print("Agent path %s" % backend_path)
sys.path.append(backend_path)

import auth_helper

private_key, public_key, pem = auth_helper.generate_keys()

with open("public_key.pem", "wb") as f:
    f.write(base64.b64encode(pem))

print("Encrypt and decrypt with python")

ciphertext = auth_helper.encrypt("hello world", public_key)

print("Ciphertext:")
print(ciphertext)

plaintext = auth_helper.decrypt(private_key, ciphertext)

print("Plaintext:")
print(plaintext)

print("Encrypt with js and decrypt with python")

# now try with javascript
cmd = "node ./encrypt.js"
subprocess.check_output(cmd, shell=True)

# now read the ciphertext file
with open("ciphertext", "rb") as ciphertext_file:
    st = ciphertext_file.read()

print("Ciphertext:")
print(st)

plaintext = auth_helper.decrypt(private_key, st)

print("Plaintext:")
print(plaintext)
