import json
import os
import sys
import pytest

backend_path = os.path.realpath(
    os.path.join(os.path.dirname(os.path.realpath(__file__)), "../")
)
print("Backend path %s" % backend_path)
sys.path.append(backend_path)

from mediator import Mediator


class TestDevice:
    @pytest.mark.parametrize(
        "input,expected",
        [
            ("", "Invalid input"),
            ("unknown", "Invalid input"),
            ({"command": "unknown"}, "Command not recognized"),
        ],
    )
    def test_apply_device_command_invalid_input(self, input, expected):
        mediator = Mediator()

        status, response = mediator.apply_device_command(input)
        assert status == False
        assert response == expected
